# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
# filter lf classification grids for single speckle cells.
#/* implements an filtering algorithm to reduce the number of
#/* misclassified relief units
#/* written by hannnes isaak reuter
#/* contact gisxperts@web.de
# F:\jrc_d_drive\GIS\dgm\srtm30\srtm30 F:\jrc_d_drive\GIS\dgm\srtm30\srtm30_1 # 
import sys, string, os, tempfile,  traceback
# debug
DEBUG = False
# DEBUG = True

# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
  # Script arguments...
  # &args file out method slope pennock thr1 thr2 thr3
Expression = sys.argv[1] # input dataset
dem_out = sys.argv[2]
if len(sys.argv) >= 4:
    DEBUG = sys.argv[3]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# create variables for workspace
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
dem,workspace = tp.getnameandworkspace_base(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
# check output data exists
outdem,outworkspace = tp.checkoutput(dem_out,os,gp)
# define windows exact like the original values
gp.extent = tp.getextent(Expression,gp)
# clean temp files
tp.cleanttempfile4(gp,scratchWS,workspace,os)

# out put file name
# copy input grid to work grid - needed for loop for focal_stats
# don't use copy with copy_management.. works in Pythonwin, but not in arccatalog
try: # copy problems
  tp.gtbmsg("Start conversion from 16int to real values",dem,gp)
  # get conversion running  
  tp.convert16bit(Expression,dem_out,gp)
 # final clean up
# clean temp files
  if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)

  gp.CheckInExtension("spatial")
     # so we see something if do error testing in idlde
  tp.gtbmsg("finished convert16bit.py ok for ",dem,gp)
  

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
  # clean temp files
  tp.cleantempfile4(gp)