# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
## ---------------------------------------------------------------------------
# elevres.py
#
# ---------------------------------------------------------------------------
# C:\WorkSpace\pythontbx\d25m2 5
# F:\jrc_d_drive\geomorphometryTB\test\aire 5 1
# Import system modules
import sys, string, os, traceback
# Script arguments...

#print sys.argv
#for arg in sys.argv:
#    print arg
#print sys.argv[1]
#print sys.argv[2]
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

Expression = sys.argv[1]
#print Expression
Expression1 = sys.argv[2]
if Expression1 == '#':
    Expression1 = "11"
InNeighborhood = sys.argv[3]
if InNeighborhood =='#':
    InNeighborhood = "Rectangle " + Expression1 + " " + Expression1 + " CELL"
tp.gtbmsg("Use the following Neighborhood ",InNeighborhood,gp)
# debug - needs to be at 1 and DEBUGSCRATCH variable must be set to run in DEBUG MODE
if len(sys.argv) >= 5:
    DEBUG = sys.argv[4]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace_base(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
# provide a default value if unspecified
# implement to delete all overwritable directories..
# overwrite option is again not enough to make sure its written... ( especially in case of bailing)
# Local variables...
#dem_mean = dem + "mean"+ Expression1
#dem_medi = dem+ "medi"+ Expression1
#dem_sum = dem+ "sum"+ Expression1
#dem_diff = dem+ "diff"+ Expression1
#dem_sd = dem+ "sd"+ Expression1
#dem_rang = dem+ "rang"+ Expression1
#dem_dev = dem+ "dev"+ Expression1
#dem_pctg = dem+ "pctg"+ Expression1
#dem_min = dem+ "min"+ Expression1
#dem_max = dem+ "max"+ Expression1
#dem_vari = dem+ "vari"+ Expression1
# dem_med = dem+ "med"+ Expression1
#dem_i = dem+'i'
#nodata_slp_assignment_ = "0"

try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    # define neighnourhood for all processes
    InRaster = dem
    InNoDataOption = "DATA"
    # define windows smaller than the original values
    gp.extent = tp.getextentforxcells(dem,Expression1,gp)
    tp.elevres(workspace+dem,Expression1,InNeighborhood,InNoDataOption,gp,scratchWS)
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)

    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for elevres.py for ",dem,gp)
    
except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
