# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
# ---------------------------------------------------------------------------
# C:\WorkSpace\pythontbx\d25m2 C:\WorkSpace\pythontbx\a25m_soter # # # # # #
# F:\jrc_d_drive\geomorphometryTB\test\d25 F:\jrc_d_drive\geomorphometryTB\test\d25lfpark # # # # # 
# ---------------------------------------------------------------------------
def kernel3by3():
    tp.gtbmsg("Write 3 by 3 kernel file",'',gp)
    fd,aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="3 3" ;        tmp.write(cmd+'\n')
    cmd="1 1 1" ;        tmp.write(cmd+'\n')
    cmd="1 0 1" ;        tmp.write(cmd+'\n')
    cmd="1 1 1" ;        tmp.write(cmd+'\n')
    tmp.close()
    return(aml)

def kernel5by5():
    tp.gtbmsg("Write 5 by 5 kernel file",'',gp)
    fd,aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="5 5" ;        tmp.write(cmd+'\n')
    cmd="1 1 1 1 1" ;        tmp.write(cmd+'\n')
    cmd="1 0 0 0 1" ;        tmp.write(cmd+'\n')
    cmd="1 0 0 0 1" ;        tmp.write(cmd+'\n')
    cmd="1 0 0 0 1" ;        tmp.write(cmd+'\n')
    cmd="1 1 1 1 1" ;        tmp.write(cmd+'\n')
    tmp.close()
    return(aml)


def kernel7by7():
    tp.gtbmsg("Write 7 by 7 kernel file",'',gp)
    fd,aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="7 7" ;        tmp.write(cmd+'\n')
    cmd="1 1 1 1 1 1 1" ;        tmp.write(cmd+'\n')
    cmd="1 0 0 0 0 0 1" ;        tmp.write(cmd+'\n')
    cmd="1 0 0 0 0 0 1" ;        tmp.write(cmd+'\n')
    cmd="1 0 0 0 0 0 1" ;        tmp.write(cmd+'\n')
    cmd="1 0 0 0 0 0 1" ;        tmp.write(cmd+'\n')
    cmd="1 0 0 0 0 0 1" ;        tmp.write(cmd+'\n')
    cmd="1 1 1 1 1 1 1" ;        tmp.write(cmd+'\n')
    tmp.close()
    return(aml)



# make file name section
# Import system modules
# "C:\WorkSpace\pythonbox2\d25m2" "#" "#" "#" "#"
import sys, string, os, tempfile,  traceback
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
Expression = sys.argv[1]
output = sys.argv[2]
cl_csi = sys.argv[3]
cl_asi = sys.argv[4]
cl_ast = sys.argv[5]
cl_ap = sys.argv[6]
# DEBUG = True
if len(sys.argv) >= 8:
    DEBUG = sys.argv[7]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace_base(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
# output check
outdem,outworkspace = tp.checkoutput(output,os,gp)
# how to handle nodata
InNoDataOption = "DATA"

# local var
dem_cs = dem + "cs"
dem_as = dem + "as"

dem_tci = dem + "tci"
dem_ld = dem + "ld"
dem_ldvar = dem + "ldvar"
dem_ldstd = dem + "ldstd"
dem_ldmaj = dem + "ldmaj"
dem_ldf = dem + "ldf"
Output_drop_raster = ''
# see below for cs3 calclation if changing 
max_extend = 24 

try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.Extent = tp.getextentforxcells(dem,0,gp)
    # define windows smaller than the original values
    # based on a paper by park 2001 in geoderma 102 pp.249-272
    aml3 = kernel3by3()
    aml5 = kernel5by5()
    aml7 = kernel7by7()
    tp.parkprep(dem,dem_cs,dem_as,dem_tci,aml3,aml5,aml7,max_extend,ARCINFO,workspace,tempfile,os,gp,scratchWS)

# report parameters of AS and CS
    if  gp.Exists(dem_cs):
        tp.gtbmsg("Minimum CS is: " + str(gp.GetRasterProperties_Management(dem_cs, "MINIMUM")),'',gp)
        tp.gtbmsg("Maximum CS is: " + str(gp.GetRasterProperties_Management(dem_cs, "MAXIMUM")),'',gp)
        tp.gtbmsg("Mean CS is: " + str(gp.GetRasterProperties_Management(dem_cs, "MEAN")),'',gp)
        tp.gtbmsg("Stdv CS is: " + str(gp.GetRasterProperties_Management(dem_cs, "STD")),'',gp)
    if cl_csi == "#":
       cl_csi =  (gp.GetRasterProperties_Management (dem_cs, "STD")  / 4)
    if cl_asi == "#" :
       cl_asi = 2.5
    if cl_ast == "#" :
       cl_ast = 3.5
    if cl_ap == "#" :
       cl_ap = 4
    tp.gtbmsg( 'Use the following CSI/ASI/AST/AP values: '+str(cl_csi)+', '+str(cl_asi)+', '+str(cl_ast)+', '+str(cl_ap),'',gp)
    #/* 1 channel
    #/* 2 shoulder
    #/* 3 footslope
    #/* 4 interfluve
    #/* 5 toeslope
    #/* 6 backslope
    # clean temp files
    if gp.Exists(dem_ld):
        gp.delete_management(dem_ld)
    if version == '2.6.':
        tp.parkclassnumpy(dem_cs,dem_as,dem_ld,cl_csi,cl_asi,cl_ast,cl_ap,ARCINFO,workspace,tempfile,os,gp)
    else:
        tp.parkclass(dem_cs,dem_as,dem_ld,cl_csi,cl_asi,cl_ast,cl_ap,ARCINFO,workspace,tempfile,os,gp)
    gp.Extent = tp.getextentforxcells(dem,max_extend,gp)
    # /* assumption if varity = 2 and std > 0.8 than replace by majority
    if gp.Exists(dem_ld):
        tp.parkfilter(dem_ld,output,gp,scratchWS)
    else:
       tp.gtbmsg("GRID does not exits - no filtering could be performed: ",dem_ld,gp)

    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)

    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished for lfpark.py for ",output,gp)
    tp.gtbmsg("Finished for lfpark.py for ",dem_ld,gp)

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
        tp.errorcall(sys,gp,traceback)