# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
## ---------------------------------------------------------------------------
# rescale.py
#
# ---------------------------------------------------------------------------
# C:\WorkSpace\pythontbx\d25m2 25
# D:\geomorphometryTB\test2\d25m2 D:\geomorphometryTB\test2\z25m 25
# Import system modules
import sys, string, os, traceback
# debug
DEBUG = False
# DEBUG = True

# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)

# Script arguments...
Expression = sys.argv[1]
Expression1 = sys.argv[3]
out = sys.argv[2]
outdem,outworkspace = tp.checkoutput(out,os,gp)

# 25 is the parameter which has been used in the LAP-MII Report by MacMillan and Pettapiece
if Expression1 == '#':
 Expression1 = "25"

# create variables for workspace
dem,workspace = tp.getnameandworkspace(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
# provide a default value if unspecified
# implement to delete all overwritable directories..
# overwrite option is again not enough to make sure its written... ( especially in case of bailing)
# Local variables...nodata_slp_assignment_ = "0"

try:
    # clean temp files
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    min,max,mean,std = tp.getelevationrange(dem,gp)

    gp.SingleOutputMapAlgebra_sa('(( '+dem+' - '+str(min)+' ) / ('+str(max)+' - '+str(min)+' )) * '+Expression1, out)

    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for rescale.py for "+dem+' into ',out,gp)
    

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
