# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
## ---------------------------------------------------------------------------
# openness.py
# Import system modules
#F:\jrc_d_drive\geomorphometryTB\test\d25 F:\jrc_d_drive\geomorphometryTB\test\d25pos F:\jrc_d_drive\geomorphometryTB\test\d25neg 5
import sys, string, os,  traceback,tempfile
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
Expression = sys.argv[1]
output = sys.argv[2]
output2 = sys.argv[3]
Expressionx = sys.argv[4]
if Expressionx == '#':
    Expressionx = 5
if len(sys.argv) >= 6:
    DEBUG = sys.argv[5]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# create variables for workspace
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
dem,workspace = tp.getnameandworkspace_nounit(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
outdem,outworkspace = tp.checkoutput(output,os,gp)
outdem2,outworkspace2 = tp.checkoutput(output2,os,gp)
# local variables
dem_i = dem+'in'
try:
    #clean tem p files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.extent = tp.getextentforxcells(dem,0,gp) 
# get positive openeness
    tp.gtbmsg('calculate positive openness for:',dem,gp)
    tp.openness(dem,output,Expressionx,gp,workspace,scratchWS,ARCINFO,string,os,tempfile,DEBUG)
# get negative openeness
    tp.getidem(dem,dem_i,gp,scratchWS)
    tp.gtbmsg('calculate negative openness for:',dem_i,gp)
    tp.openness(dem_i,output2,Expressionx,gp,workspace,scratchWS,ARCINFO,string,os,tempfile,DEBUG)
    
# final clean up
    gp.CheckInExtension("spatial")
    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("finished Openness.py for ",dem,gp)
    
except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)


