# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
## ---------------------------------------------------------------------------
# outlier.py
# Created on: lun ott 03 2005 08:06:32 PM
#   (generated by ArcGIS/ModelBuilder)
#
# ---------------------------------------------------------------------------
# inputdem typeprocess std extent outliertest
# Import system modules
# improv: remove outliers from mean value generation as in aml code..
# D:\geomorphTB220222009\testbox\d25 D:\geomorphTB220222009\testbox\d25_outlf static 20 3 true

import sys, string, os, traceback
# debug
DEBUG = False
# DEBUG = True

# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
inputdem = sys.argv[1]
dem_out = sys.argv[2]
typeprocess = sys.argv[3]
std = sys.argv[4]
extent = sys.argv[5]
outliertest1 = sys.argv[6]
#print outliertest
#gp.addmessage (outliertest)
if typeprocess == '#':
 typeprocess = "static"
if std == '#':
 std = "2"
if extent == '#':
    extent = 3
if outliertest1 == '#':
    outliertest1 = 'false'

outliertest =tp.str2bool(outliertest1)
if outliertest:
    outliervalue = '-4444'
# setup
if len(sys.argv) >= 8:
    DEBUG = sys.argv[7]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace_base(inputdem,os,gp,string,DEBUG)
gp.workspace = workspace
outdem,outworkspace = tp.checkoutput(dem_out,os,gp)

try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    # Local variables...
    dem_mean = tp.scratchgrid(dem,scratchWS,gp)
    dem_std = tp.scratchgrid(dem,scratchWS,gp)
    tmp12343 = tp.scratchgrid(dem,scratchWS,gp)
    #get neighborhood stuff    
    InNeighborhood = "Rectangle " + str(extent) + " " + str(extent) + " CELL"
    InNoDataOption = "DATA"
    if typeprocess == "static":
    # static approach
    # get stats par
    #/* mean elevation
    #/* smoothed DEM
        gp.FocalStatistics_sa(dem, dem_mean, InNeighborhood, "MEAN", InNoDataOption)
        if outliertest :
            inExpression = 'con ( '+dem+' < '+dem_mean+' + '+std+' , con ( '+dem+' > '+dem_mean+' - '+std+' , '+dem+' , '+outliervalue+' ) , '+outliervalue+' )'
            gp.SingleOutputMapAlgebra_sa( inExpression, dem_out )
        else:
            inExpression = 'setnull ( '+dem+' > '+dem_mean+' + '+std+' , setnull ( '+dem+' < '+dem_mean+' - '+std+' , '+dem+' ) ) '
            gp.SingleOutputMapAlgebra_sa( inExpression, tmp12343 )
            tp.filter_mw(tmp12343,dem_out,gp,scratchWS)    
    else:
    # dynamic approach
        gp.FocalStatistics_sa(dem, dem_mean, InNeighborhood, "MEAN", InNoDataOption)
        gp.FocalStatistics_sa(dem, dem_std, InNeighborhood, "STD", InNoDataOption)
        if outliertest :
            inExpression = 'con ( '+dem+' < ( '+dem_mean+' + '+std+' * '+dem_std+' ) , con ( '+dem+' > ( '+dem_mean+' - '+std+' * '+dem_std+' ) , '+dem+' , '+outliervalue+' ), '+outliervalue+' )'
            gp.SingleOutputMapAlgebra_sa( inExpression, dem_out )
        else:
            inExpression = 'setnull ( '+dem+' > ( '+dem_mean+' + '+std+' * '+dem_std+' ) , setnull ( '+dem+' < ( '+dem_mean+' - '+std+' * '+dem_std+' ) , '+dem+' ) ) '
            gp.SingleOutputMapAlgebra_sa( inExpression, tmp12343 )
            tp.filter_mw(tmp12343,dem_out,gp,scratchWS) 

    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for outlier.py for ",dem,gp)
    

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
