# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
# C:\WorkSpace\pythontbx\d25m2 5
# Import system modules
import sys, string, os, traceback
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
Expression = sys.argv[1]
dem_out = sys.argv[2]
method = sys.argv[3]
# check for method - done now in routine itself..
Expression1 = sys.argv[4]
if Expression1 == '#':
    Expression1 = "20"
# DEBUG
if len(sys.argv) >= 6:
    DEBUG = sys.argv[5]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace_base(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
outdem,outworkspace = tp.checkoutput(dem_out,os,gp)

try:
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    # define neighnourhood for all processes
    tp.sinkfill(dem, outdem, method, Expression1, gp, os, scratchWS)
    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for sinkfilling.py for ",dem,gp)

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
