# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
# ---------------------------------------------------------------------------
# C:\WorkSpace\pythontbx\d25m2 C:\WorkSpace\pythontbx\d25m2_source 0.2
# Import system modules
# D:\geomorphometryTB\test\d25m2 D:\geomorphometryTB\test\d25m2_tpi # # # # #
# F:\jrc_d_drive\geomorphometryTB\test\d25 F:\jrc_d_drive\geomorphometryTB\test\d25_dickosn # # DICKSON # #

import sys, string, os, traceback,tempfile,textwrap
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
# Script arguments...
Expression = sys.argv[1]
outfile = sys.argv[2]
inner = sys.argv[3]
if inner == '#':
 inner = "5"
outer = sys.argv[4]
if outer == '#':
 outer = "10"
method = sys.argv[5]
if method == '#':
 method = "WEISS"
slp_thr = sys.argv[6]
tp.gtbmsg('Method is : '+str(method),'',gp)
if slp_thr == '#' and method == 'WEISS':
 slp_thr = 5
if slp_thr == '#' and method == 'DICKSON':
 slp_thr = 6
if slp_thr == '#' and method == 'FREE':
 slp_thr = 5
 
tp.gtbmsg('Slope Threshold is: '+str(slp_thr),'',gp)
std_thr = sys.argv[7]
if method == 'FREE' and std_thr == '#':
    std_thr = 5
    tp.gtbmsg('TPI Dividing Threshold is: '+str(std_thr),'',gp)
if std_thr == '#':
    std_thr = 0.5
    tp.gtbmsg('Standard Deviation Multiplier is: '+str(std_thr),'',gp)
if len(sys.argv) >= 9:
    DEBUG = sys.argv[8]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace_base(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
outdem,outworkspace = tp.checkoutput(outfile,os,gp)
# provide a default value if unspecified
# implement to delete all overwritable directories..
# overwrite option is again not enough to make sure its written... ( especially in case of bailing)
# Local variables...
dem_slp = dem + "slp"
dem_tpi = dem + "tpi"+inner+outer

try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
   #/* slope for backslope classifications
    tp.getslope(dem,dem_slp,"DEGREE","1",gp)
    # get tpi     
    tp.gettpi(dem,dem_tpi,inner,outer,"MEAN",gp,scratchWS)
    # /* get TPI parameters
    gp.Extent = tp.getextentforxcells(dem,outer,gp)
    if gp.Exists(outfile):
          gp.delete_management(outfile)
    if method == "DICKSON":
        if version == '2.6.':
            tp.lfdicksonnumpy(dem_tpi,outfile,dem_slp,slp_thr,ARCINFO,workspace,tempfile,gp,os,textwrap)
        else:
            tp.lfdickson(dem_tpi,outfile,dem_slp,slp_thr,ARCINFO,workspace,tempfile,gp,os,textwrap)
    if method == "WEISS":
        zmin,zmax,mean,std= tp.getelevationrange(dem_tpi,gp)
        std05 = float(std_thr) * float(std)
        if version == '2.6.':
            tp.lfweissnumpy(std05,dem_tpi, outfile,dem_slp,slp_thr,ARCINFO,workspace,tempfile,gp,os,textwrap)
        else:
            tp.lfweiss(std05,dem_tpi, outfile,dem_slp,slp_thr,ARCINFO,workspace,tempfile,gp,os,textwrap)
    else: # Version where the TPI threshold can be freely choosen .. (tpi threshold is in the variable std_thr
        if version == '2.6.':
            tp.lftpifreenumpy(dem_tpi,outfile,dem_slp,slp_thr,std_thr,ARCINFO,workspace,tempfile,gp,os,textwrap)
        else:
            tp.lftpifree(dem_tpi,outfile,dem_slp,slp_thr,tpi_thr,ARCINFO,workspace,tempfile,gp,os,textwrap)
   # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.Extent = tp.getextentforxcells(dem,0,gp)        
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for tpi.py for "+dem+' and outfile:',outfile,gp)
    

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
