# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
## ---------------------------------------------------------------------------
# zonalstatistics2.py
# F:\jrc_d_drive\geomorphometryTB\test\banjo\ddrbas Value F:\jrc_d_drive\geomorphometryTB\test\banjo\ddr F:\jrc_d_drive\geomorphometryTB\test\tt4 MEAN DATA 1
# D:\geomorphTB220222009\testbox\d25 D:\geomorphTB220222009\testbox\d25dd D:\geomorphTB220222009\testbox\d25out

import sys, string,tp, os, traceback
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
inputdem = sys.argv[1]
value_column = sys.argv[2]
if value_column =='#':
    value_column = 'value'
stats_grid = sys.argv[3]
dem_out = sys.argv[4]
Statstype = sys.argv[5]
if Statstype =='#':
    Statstype = 'MEAN'
if Statstype not in ('MEAN','MAJORITY','MAXIMUM','MEDIAN','MINIMUM','MINORITY','RANGE','STD','SUM','VARIETY'):
    tp.gtberror('Statistics can only be the DEFINED Statistics from ArcGIS','',gp)
Nodatahandling = sys.argv[6]
if Nodatahandling == '#':
    Nodatahandling = 'DATA'
if Nodatahandling not in ('DATA','NODATA'):
    tp.gtberror(' Nodata can only be DATA or NODATA','',gp)
if len(sys.argv) >= 8:
    DEBUG = sys.argv[7]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
dem,workspace = tp.getnameandworkspace_base(inputdem,os,gp,string,DEBUG)
statsdem,statsworkspace = tp.getnameandworkspace_base(stats_grid,os,gp,string,DEBUG)
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
gp.workspace = workspace
outdem,outworkspace = tp.checkoutput(dem_out,os,gp)
# provide a default value if unspecified
try:
    # clean temp files
    tp.ZonalStatistics2(dem, value_column, stats_grid, outworkspace+outdem, Statstype, Nodatahandling,gp,os,scratchWS)
    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for zonalstatistics2.py for ",dem,gp)
    

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
